#ifndef _DOACCEPT_CPP
#define _DOACCEPT_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN
#define _WIN32_WINNT 0x0500

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <WinSock2.H>
#include <WinSock.H>
#include <Stdio.H>
#include <Stdlib.H>

#include "CSockSrvr.H"

#include "../../SharedSource/Debug.H"
#include "../../SharedSource/NSWFL.H"
#include "../../SharedSource/HashKey.H"

#include "../Source/Entry.H"
#include "../Source/Routines.H"
#include "../Source/HandShake.H"
#include "../Source/Command.H"

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool CSockSrvr::DoAccept(void)
{
    #ifdef _DEBUG_SOCK_SERVER
    printf("DEBUG: [In Proc]> CSockSrvr::DoAccept.\n");
    #endif

	if(FD_ISSET(sckcListenSocket, &ReadFDS))
	{
		int iClient = 0;
		int iLength = 0;
		SOCKET sckLocalSocket = 0;

		SOCKADDR_IN RemoteClientSocketAddress;

		iLength = sizeof(SOCKADDR);
		if((sckLocalSocket = accept(sckcListenSocket, (SOCKADDR*)&RemoteClientSocketAddress, &iLength)) == SOCKET_ERROR)
		{
			WriteSysLogEx("CSockSrvr::DoAccept : accept returned SOCKET_ERROR\n", EVENT_ERROR);
			return false;
		}

		if(sckLocalSocket == 0)
		{
            WriteSysLogEx("CSockSrvr::DoAccept : accept returned 0\n", EVENT_ERROR);
			return false;
		}

		if(icCurrentClients == icMaxClients)
		{
            WriteSysLogEx("CSockSrvr::DoAccept : Accept Failed. Too Many Clients.\n", EVENT_ERROR);

			WSASendDisconnect(sckLocalSocket, NULL);
			shutdown(sckLocalSocket, SD_BOTH);
			closesocket(sckLocalSocket);
			return false;
		}

		if((iClient = GetFreeSocketSlot()) == -1)
		{
            WriteSysLogEx("CSockSrvr::DoAccept : Accept Failed. Not Enough Resources.\n", EVENT_ERROR);
			WSASendDisconnect(sckLocalSocket, NULL);
			shutdown(sckLocalSocket, SD_BOTH);
			closesocket(sckLocalSocket);
			return false;
		}

		bcWasConnect[iClient] = false;

		if(!OnAcceptConnectClient(iClient))
        {
            WriteSysLogEx("CSockSrvr::DoAccept : Accept Failed. OnAcceptConnectClient returned false.\n", EVENT_ERROR);
			WSASendDisconnect(sckLocalSocket, NULL);
			shutdown(sckLocalSocket, SD_BOTH);
			closesocket(sckLocalSocket);
        }

		if(!Events.OnAccept(this, iClient))
		{
			WriteSysLogEx("CSockSrvr::DoAccept : Accept Failed. OnAccept returned false.\n", EVENT_ERROR);
			WSASendDisconnect(sckLocalSocket, NULL);
			shutdown(sckLocalSocket, SD_BOTH);
			closesocket(sckLocalSocket);
		}

        icClientID[iClient] = icNextClientID++;
		bcConnected[iClient] = true;
		bcDisconnect[iClient] = false;
		sckcSocket[iClient] = sckLocalSocket;

		char sText[255];
		sprintf(sText, "Connection Source:  %s : %d",
			inet_ntoa(RemoteClientSocketAddress.sin_addr), // IP Address
			ntohs(RemoteClientSocketAddress.sin_port) // Port
		);

		WriteLogEx(icClientID[iClient], sText, EVENT_NONE);

		icCurrentClients++;

        return Start_ClientThread(iClient);
	}

	return false;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

